function bufferIndices = circular_buffer_map_linear_indices(circularBuffer, linearIndices)
% bufferIndices = circularBuffer = circular_buffer_map_linear_indices(linearIndices)
% maps linear array indices to indices in buffer. Maximum linear index number is equal to the capacity of the buffer. 

bufferIndices = linearIndices + circularBuffer.startId - 1;
higherThanBufferLength = bufferIndices > circularBuffer.length;
bufferIndices(higherThanBufferLength) = bufferIndices(higherThanBufferLength) - circularBuffer.length;

if ~isempty(linearIndices)
    assert(max(linearIndices) <= circularBuffer.length - 1, ['Requested circular-buffer index is out of range: linear index = ' num2str(max(linearIndices))]);
end;
