function varargout = mr_dashboard(varargin)
% shows a 'dashboard' which contains useful information regarding MatRiver such as execution-lags and timer status. It can also, Start, Pause and Terminate MatRiver main timer. 
% to set the callback for 'Start' button (which launches a MatRiver timer from the assigned script), use this format:
% 
% >> mr_dashboard('mr_viewdata;');
% this will launch mr_viewdata() the first time Start button is pressed.

% Native GUI help:
% MATRIVERGUI M-file for mr_dashboard.fig
%      mr_dashboard, by itself, creates a new mr_dashboard or raises the existing
%      singleton*.
%
%      H = mr_dashboard returns the handle to a new mr_dashboard or the handle to
%      the existing singleton*.
%
%      mr_dashboard('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in mr_dashboard.M with the given input arguments.
%
%      mr_dashboard('Property','Value',...) creates a new mr_dashboard or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mr_dashboard_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mr_dashboard_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mr_dashboard

% Last Modified by GUIDE v2.5 13-Aug-2009 16:02:40

% Begin initialization code - DO NOT EDIT

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @mr_dashboard_OpeningFcn, ...
    'gui_OutputFcn',  @mr_dashboard_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mr_dashboard is made visible.
function mr_dashboard_OpeningFcn(hObject, eventdata, handles, varargin)

global accumulatorTimer
global timerStillRunning
global dashboardUpdateTimer

%If user accidently closes Matriver GUI and timer is still running Start
%button will change to Pause

timerStillRunning = ~isempty(accumulatorTimer) && isvalid(accumulatorTimer) && strcmp(get(accumulatorTimer,'Running'),'on'); 

if  timerStillRunning
    startObject = findobj('Tag','Start');
    startString = get(startObject, 'String');
    set(startObject,'String','Pause'); %Changes Start button to Pause
    start(dashboardUpdateTimer);
end;

if nargin>0    
    startFunctionObject = findobj('Tag','startFunction'); %This calls the object startFunction
    set(startFunctionObject, 'String', varargin{1}); %This sets the string in the text box to first input argument
end;


% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mr_dashboard (see VARARGIN)

% Choose default command line output for mr_dashboard
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mr_dashboard wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mr_dashboard_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Start.
function Start_Callback(hObject, eventdata, handles)
% hObject    handle to Start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global accumulatorTimer
global displayTimer
global dashboardUpdateTimer

timerHasProblem = isempty(accumulatorTimer) || ~isvalid(accumulatorTimer); %To prevent accumulatorTimer program to 
                                                                           %run from the beginning of the data
                                                                           

startObject = findobj('Tag','Start'); %This calls the object start
startString = get(startObject, 'String'); %This gets the start button's string

%Starts the function typed in the text box
if timerHasProblem
    set(startObject,'String','Pause'); %Changes the start button to Pause after clicking
    startFunctionObject = findobj('Tag','startFunction'); %This calls the object startFunction
    startFunctionString = get(startFunctionObject, 'String'); %This gets the string from the text box
    eval(startFunctionString); %Runs the function typed in the text box
    
    %Start the dashboard update timer to start plotting the execution lag
    %and listing of bad channels
    dashboardUpdateTimer = timer('TimerFcn','mr_plot_execution_lag; mr_list_bad_channels','StartDelay',0,'ExecutionMode','fixedSpacing','period',1);
    start(dashboardUpdateTimer);
    
else
    
    buttonLabelIsStart = strcmp(startString, 'Start');%This compares the button's string to the string Start
                                                      %buttonLabelIsStart = 1 (or true)
                                                      %Basically switches the button from Start to Pause
                                                    
    %Starts and pauses the timers
    
    if buttonLabelIsStart
        set(startObject,'String','Pause'); %Changes Start button to Pause
        start(timerfindall); % Resumes the timers
    else
        set(startObject,'String','Start'); %Changes Pause button to Start
        stop(timerfindall); %Pauses the timers
    end;
end;

% --- Executes on button press in Terminate.
function Terminate_Callback(hObject, eventdata, handles)
%Changes Pause button to Start after clicking terminate

startObject = findobj('Tag','Start');
startString = get(startObject, 'String');
set(startObject,'String','Start');

delete(timerfindall); %Deletes all the timers stops the program

% hObject    handle to Terminate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes during object creation, after setting all properties.
function startFunction_CreateFcn(hObject, eventdata, handles)
% hObject    handle to startFunction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function executionLag_CreateFcn(hObject, eventdata, handles)

global executionLagPlotAxisHandle

executionLagPlotAxisHandle = gca; %Puts a blank axis on the GUI

% hObject    handle to executionLag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate executionLag


% --- Executes on selection change in badChannelList.
function badChannelList_Callback(hObject, eventdata, handles)
% hObject    handle to badChannelList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns badChannelList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from badChannelList


% --- Executes during object creation, after setting all properties.
function badChannelList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to badChannelList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

global badChannelListHandle

badChannelListHandle = hObject;


