function mr_eeg_ocean_cortex

global mr

persistent figureHandle fsfVertextDistanceToDipole numberOfColorsInTheColormap colorMapIsHasNegative fsfHandle maxFrameDistance;
persistent numberOfRunsSofar lastMax lastMin dipoleProjectionOnAllCortext;

icIndexNumber = [1 2]; % index of ic in requested ics
% controls the mapping between time and frames
eegFrameToCortextDistanceRatio = 2.5;

if isempty(figureHandle) || ~ishandle(figureHandle)
    
    fsf = load('/home/nima/tools/eeg/MNImesh_dipfit.mat');
    
    figureHandle = figure;
    fsfHandle = plotmesh(fsf.faces, fsf.vertices, [], false);
    
    set(gcf,'Renderer' ,'opengl');
    reducepatch(fsfHandle, 1/6);
    
    % simple gaussian projection on surface
    
    gaussianStd = 10;%4;
    
    fsfVertices = get(fsfHandle(1), 'Vertices');
    clear diplePosition
    
    for i=icIndexNumber
        dipolePosition{i} = mr.eeg.dipfit.model(mr.eeg.icNumbersToCalculateActivity(i)).posxyz;        
    end;


    clear projection ;
    fsfVertextDistanceToDipole = [];
    for i=1:length(dipolePosition)
        fsfVertextDistanceToDipole(i,:) = sum( (fsfVertices - repmat(dipolePosition{i}, size(fsfVertices, 1), 1)) .^2, 2) .^ 0.5;
        projection(i,:) = exp((-1/(2*gaussianStd^2)) *fsfVertextDistanceToDipole(i,:));
    end;
    
    maxFrameDistance = round(max(fsfVertextDistanceToDipole(:) * eegFrameToCortextDistanceRatio));
    
    dipoleProjectionOnAllCortext = projection;

    % use jet colormap
    set(figureHandle, 'colormap',jet);
     
    numberOfColorsInTheColormap = length(get(gcf,'Colormap'));
    
    
    set(fsfHandle, 'CDataMapping','direct');
    set(fsfHandle, 'FaceColor','interp');
    
    % for the mean max and min used in the colormap 
    numberOfRunsSofar = 0;
    lastMin = 0;
    lastMax = 0;
    
end;

if mr_raw_to_ic_activity((mr.numberOfFramesInAccumulatedData-maxFrameDistance):mr.numberOfFramesInAccumulatedData)   
    
        
    totalDipoleProjection = 0;
    for i=1:size(fsfVertextDistanceToDipole, 1)
        activityToPlot = abs(hilbert(mr.eeg.icActivity(i,:)));
        totalDipoleProjection =  totalDipoleProjection + activityToPlot(max(1, round(end - fsfVertextDistanceToDipole(i,:)*eegFrameToCortextDistanceRatio))) .* dipoleProjectionOnAllCortext(i,:);        
    end;
    
    %lastMin = (lastMin * numberOfRunsSofar + min(totalDipoleProjection(:))) / (numberOfRunsSofar+1);
    lastMax = (lastMax * numberOfRunsSofar + max(totalDipoleProjection(:))) / (numberOfRunsSofar+1);
    numberOfRunsSofar = numberOfRunsSofar + 1;
    
    
    if colorMapIsHasNegative
        maxAbsProjection = max(abs(totalDipoleProjection));
        adjustedTotalDipoleProjectionOverAllFrames = 0.5 * totalDipoleProjection / maxAbsProjection; % map the max value to 0.5
        colorValue =  (adjustedTotalDipoleProjectionOverAllFrames+ 0.5) * (numberOfColorsInTheColormap);
    else
        adjustedTotalDipoleProjectionOverAllFrames = totalDipoleProjection / lastMax;
        adjustedTotalDipoleProjectionOverAllFrames(adjustedTotalDipoleProjectionOverAllFrames>1) = 1;
        colorValue =  adjustedTotalDipoleProjectionOverAllFrames * (numberOfColorsInTheColormap);
    end;
    
    
    set(fsfHandle, 'Cdata', colorValue);
    drawnow;
end;

