function mr_eeg_ocean_multi_band

global mr

persistent figureHandle axisHandle frameDistanceToIc im numberOfRunsSofar lastMin lastMax maxFrameDistance imageHandle bandAmplitudeBaseline;

imageWidth = 400;
imageHeight = 400;

icLocation(1,:) = [100 100];
icLocation(2,:) = [300 300];
icLocation(3,:) = [100 300];
icLocation(4,:) = [300 100];

icIndexNumber = [1]; % index of ic in requested ics

eegFrameToImagePixelRatio = 2;

if isempty(figureHandle) || ~ishandle(figureHandle) || ~ishandle(axisHandle)
    figureHandle = figure;
    axisHandle = gca;
    axis equal;
    if mr.verboseLevel > 0
        fprintf('new figure create\n');
    end;
    
    frameDistanceToIc = {};
    maxFrameDistance = -Inf;
    for i=1:size(icLocation, 1)
        im = zeros(imageWidth, imageHeight);
        
        im(icLocation(i,1), icLocation(i,2)) = 1;
        
        
        frameDistanceToIc{i} = bwdist(im);
        frameDistanceToIc{i} = round(frameDistanceToIc{i}(:) * eegFrameToImagePixelRatio);
        maxFrameDistance = max(maxFrameDistance, max(frameDistanceToIc{i}));
    end;
    
    numberOfRunsSofar = 0;
    lastMin = 0;
    lastMax = 0;
    bandAmplitudeBaseline = [0 0 0];
end;


if mr_raw_to_ic_activity((mr.numberOfFramesInAccumulatedData-maxFrameDistance):mr.numberOfFramesInAccumulatedData);
    
    %im(:) = abs(mr.accumulatedData(50, max(1, mr.numberOfFramesInAccumulatedData - frameDistanceToIc{1})));
    %im(:) = abs(mr.eeg.icActivity(icIndexNumber(1), max(1, end - frameDistanceToIc{1})));
    
    bands =[4 8;8 13.5; 13.5 45];   
    
    for bandId=1:3
        timeSeries = mr.eeg.icActivity(icIndexNumber(1),:);
        [bFilter,aFilter] = butter(3,bands(bandId,1)/(mr.samplingRate/2),'high');
        timeSeries = filtfilt(bFilter,aFilter, timeSeries);
        
        [bFilter,aFilter] = butter(3,bands(bandId,2)/(mr.samplingRate/2),'low');
        timeSeries = filtfilt(bFilter,aFilter, timeSeries);
        
        activityToPlot(bandId,:) = abs(hilbert(timeSeries));
        bandAmplitudeBaseline(bandId) = bandAmplitudeBaseline(bandId) + mean(activityToPlot(bandId,:));
    end;
    
    numberOfRunsSofar = numberOfRunsSofar +1;
    
    meanBandAmplitudeBaseline = bandAmplitudeBaseline / (numberOfRunsSofar);
    im(:) = activityToPlot(1,max(1, end - frameDistanceToIc{1})) / meanBandAmplitudeBaseline(1);
    imRGB(:,:,1) = im;
    
    im(:) = activityToPlot(2,max(1, end - frameDistanceToIc{1}))/ meanBandAmplitudeBaseline(2);
    imRGB(:,:,2) = im;
    
    im(:) = activityToPlot(3,max(1, end - frameDistanceToIc{1}))/ meanBandAmplitudeBaseline(3);
    imRGB(:,:,3) = im;
    
    imRGB = imRGB / max(imRGB(:));
    
    if numberOfRunsSofar ==1
        imageHandle = imshow(imRGB);
    else
        set(imageHandle, 'cdata', imRGB);
    end;
    
    
    
%     
%     for i=2:length(icIndexNumber)
%         %im(:) =  im(:) + abs(mr.accumulatedData(80, max(1, mr.numberOfFramesInAccumulatedData - frameDistanceToIc{i}))');
%         %im(:) =  im(:) + abs(abs(mr.eeg.icActivity(icIndexNumber(i), max(1, end - frameDistanceToIc{i})))');
%         
%         activityToPlot = abs(hilbert(mr.eeg.icActivity(icIndexNumber(i),:)));
%         im(:) = im(:) + activityToPlot(max(1, end - frameDistanceToIc{i}))';
%     end;
%     
%     % update min and max for coloring slowly and adaptively
%     lastMin = (lastMin * numberOfRunsSofar + min(im(:))) / (numberOfRunsSofar+1);
%     lastMax = (lastMax * numberOfRunsSofar + max(im(:))) / (numberOfRunsSofar+1);
%     numberOfRunsSofar = numberOfRunsSofar + 1;
%     
%     imagesc(im,'parent', axisHandle, [lastMin lastMax]);
    drawnow;
end;
