function mr_viewdata
% visualizes the real-time data flowing into the MatRiver system. 

global mr
persistent figureHandle axisHandle;
global mr_viewdata_update_figure;
global buttonHandle;
numberOfFramesToPlot = 500;
%originalFigure = gcf;

if isempty(figureHandle) || ~ishandle(figureHandle)
    figureHandle = figure;
    axisHandle = gca;
    if mr.verboseLevel > 0
        fprintf('new figure create\n');
    end;
    mr_viewdata_update_figure = true;
    
    buttonHandle = uicontrol(       ...
    'String','Pause',               ...
    'units','normalized',           ...%Units set to normalized so the button will stay proportional when figure window is resized
    'Position',[0.45 0.01 0.1 0.05],...%[left, bottom, width, height]
    'Callback','viewdata_button_callback'); 
end;

%figure(figureHandle);


if mr_viewdata_update_figure && mr.numberOfFramesInAccumulatedData > numberOfFramesToPlot+1
    y = zeros(mr.numberOfChannelsInAccumulatedData, numberOfFramesToPlot+1);
    for i=1:mr.numberOfChannelsInAccumulatedData
        y(i,:) = i + 0.8 * zscore(mr.accumulatedData(i,(mr.numberOfFramesInAccumulatedData - numberOfFramesToPlot):mr.numberOfFramesInAccumulatedData));
    end;
    
    x = 1:size(y,2);
    axisChildren = get(axisHandle ,'children');
    if isempty(axisChildren)
        plot(axisHandle, x,y,'b');
        axisChildren = get(axisHandle ,'children');
    else
        for j=1:size(y,1)
            set(axisChildren(j), 'ydata',y(j,:), 'xdata',x);
        end;
    end;
    
    
end;


xlim(axisHandle, [0 numberOfFramesToPlot+1]);
if ~isnan(mr.numberOfChannelsInAccumulatedData)
    ylim(axisHandle, [-2 mr.numberOfChannelsInAccumulatedData+3]);
end;
drawnow;


% retrun to original figure
%if originalFigure ~= figureHandle
%    figure(originalFigure);
end
