
maximumDataToReadInEachRun = 2000; % maximum number of frames to be read in each acumulation run
counter = 1;
sizeOfBlockInceaseInAccumulatedDataSize = 10000;


clear mr;
global mr;

mr = [];
maxChannels = 100;
initialLength = 5000;
mr.verboseLevel = 1; % 0 is no verbosity, 1 for medium and 2 is for max

mr.accumulatedData = nan(maxChannels, initialLength);

mr.maxNumberOfFramesInAccumulatedData = 1000;

mr.numberOfFramesInAccumulatedData  = 0;
mr. numberOfFramesReceived = 0;

mr.readFromDataRiver = false;

useCircularBuffer = true;

% profile clear;
% profile on;
tic;

if useCircularBuffer
    %mr.accumulatedData = circular_buffer_init(mr.maxNumberOfFramesInAccumulatedData, 100);
    mr_init_reading('DataRiver');
    %mr.accumulatedData = circular_buffer_init(mr.maxNumberOfFramesInAccumulatedData, 100);
end;

for i=1:50000
    
    arr_in.nItems = 100;
    arr_in.Data = rand(1, 100);
    
    if useCircularBuffer
        %  mr.accumulatedData = circular_buffer_add(mr.accumulatedData, arr_in.Data');
        mr_circular_buffer_add(1, arr_in.Data');
    else
        
        
        %newData = cat(2,newData, arr_in.Data(1:arr_in.nItems)');
        
        % add new data to the accumulator variable 'mr.accumulatedData'
        mr.numberOfChannelsInAccumulatedData = arr_in.nItems;
        
        if mr.numberOfFramesInAccumulatedData+1 > size(mr.accumulatedData)
            % expand the data if it has not resched the maximum allowed
            % size
            if mr.numberOfFramesInAccumulatedData<mr.maxNumberOfFramesInAccumulatedData
                mr.accumulatedData = cat(2, mr.accumulatedData, nan(size(mr.accumulatedData,1), sizeOfBlockInceaseInAccumulatedDataSize));
                if mr.verboseLevel > 0
                    fprintf('mr.accumulatedData expanded.\n');
                end;
            else % shrink accumulated data size if it has reached the max allowed size
                mr.accumulatedData = cat(2, mr.accumulatedData(:, (mr.numberOfFramesInAccumulatedData - mr.maxNumberOfFramesInAccumulatedData):mr.numberOfFramesInAccumulatedData), nan(size(mr.accumulatedData,1), sizeOfBlockInceaseInAccumulatedDataSize));
                mr.numberOfFramesInAccumulatedData = mr.maxNumberOfFramesInAccumulatedData;
                if mr.verboseLevel > 0
                    fprintf('mr.accumulatedData shrunk.\n');
                end;
            end;
        end;
        
        mr.accumulatedData(1:mr.numberOfChannelsInAccumulatedData, mr.numberOfFramesInAccumulatedData+1) = arr_in.Data(1:arr_in.nItems);
    end;
    
    mr.numberOfFramesInAccumulatedData = mr.numberOfFramesInAccumulatedData + 1;
    mr.numberOfFramesReceived =  mr.numberOfFramesReceived + 1;
end;
toc;
%profile off;

