%% calculate ICA and send it to a buffer

load tutorial_mr_structure.mat;
global mr
mr_init_writing('c:/tmp/Test', 256);

mr.eeg.icNumbersToCalculateActivity = 17;

mr_read_simulated(true); 

% delete all timers;
delete(timerfindall);

% define and then start the main MatRiver timer
if isempty(timerfind('tag','accumulatorTimer'))
    
    accumulatorTimer = timer('TimerFcn','mr_accumulate;mr_detect_bad_channels; mr_update_ica; numberOfNewIcaFrames = mr_raw_to_ic_activity_accumulate; mr_write_buffer(''c:/tmp/Test'', circular_buffer_last_frames(mr.eeg.accumulatedIcActivity, numberOfNewIcaFrames)*1e6);' ,'StartDelay',0,'ExecutionMode','fixedSpacing','Period',0.01,'tag','accumulatorTimer');   
    
    % start the timer
    start(accumulatorTimer);
end;
%%
mr_close_write_buffer('/tmp/Test');

%% read data from buffer continously (higher level functions)

clear mr;
global mr;
global ds_array
global ds_lib;
% cd C:\Users\Nima\Documents\alpha_version

mr = [];
mr.verboseLevel = 1;
mr.readFromDataRiver = true;
mr_init_reading('c:/tmp/Test');

figure;
for i=1:1000
    mr_accumulate_read_buffer('c:/tmp/Test');
    plot(circular_buffer_last_frames(mr.read.bufferAccumulatedData, 1000)');
    pause(0.1);
end;

mr_close_read_buffer('c:/tmp/Test');

%% read and write using higher level functions

clear mr;
global mr;
global ds_array
% cd C:\Users\Nima\Documents\alpha_version

mr = [];
mr.verboseLevel = 1;
mr.readFromDataRiver = true;
mr_init_writing('c:/tmp/Test', 15);


% IMPORTANT:
% when a buffer is opened for reading, It ONLY read data written to it
% after it has been opened (it does not return previously written data)

%hr = ds_OpenRead(mr.write.bufferName{1});
mr_init_reading('c:/tmp/Test', 1, 3234);

data = rand(2,8000) * 100;
mr_write_buffer('c:/tmp/Test', data)


% arr_out = ds_array;
% for i=1:8000
%     arr_out.nItems = 2;
%     arr_out.Data(1:2)= [i i*2]; % note that matlab arrays are 1-based and c arrays are 0-based
%     ds_Write(mr.write.bufferHandle{1}, arr_out);
% end;

for i=1:10
    mr_accumulate_read_buffer('c:/tmp/Test');
end;

mr_close_read_buffer('c:/tmp/Test');
mr_close_write_buffer('c:/tmp/Test');


%% read and write using basic low-level functions
clear mr;
global mr;
global ds_array
% cd C:\Users\Nima\Documents\alpha_version

mr = [];
mr.verboseLevel = 1;
mr_init_writing('c:/tmp/Test', 10);


% IMPORTANT:
% when a buffer is opened for reading, It ONLY read data written to it
% after it has been opened (it does not return previously written data)

%hr = ds_OpenRead(mr.write.bufferName{1});
mr_init_reading('c:/tmp/Test');

arr_out = ds_array;
for i=1:10
    arr_out.Data(1)= i; % note that matlab arrays are 1-based and c arrays are 0-based
    ds_Write(mr.write.bufferHandle{1}, arr_out);
end;

[r,arr_in]=ds_Read(mr.read.bufferHandle{1});

while r>0
    fprintf('%d - ', arr_in.Data(1));
    [r,arr_in]=ds_Read(mr.read.bufferHandle{1});
end

%ds_CloseRead(mr.read.bufferHandle{1});


mr_close_read_buffer('c:/tmp/Test');
mr_close_write_buffer('c:/tmp/Test');


%% send data to a buffer continously (lower level functions)

clear mr;
global mr;
global ds_array
% cd C:\Users\Nima\Documents\alpha_version

mr = [];
mr.verboseLevel = 1;
mr_init_writing('/tmp/maze', 10);


arr_out = ds_array;
for i=1:10000000
    arr_out.Data(1)=0;
    arr_out.Data(2:4)= rand(1,3)* 1000; % note that matlab arrays are 1-based and c arrays are 0-based
    ds_Write(mr.write.bufferHandle{1}, arr_out);
    pause(0.1);
end;

mr_close_write_buffer('/tmp/maze');

%% read data from buffer continously (lower level functions)

clear mr;
global mr;


global ds_array
% cd C:\Users\Nima\Documents\alpha_version

mr = [];
mr.verboseLevel = 1;
mr.readFromDataRiver = true;
mr_init_reading('c:/tmp/Test');


for i=1:1000
    
    r = 1;
    while r>0
        [r,arr_in]=ds_Read(mr.read.bufferHandle{1});
        if r>0
            fprintf('%f \n', arr_in.Data(1));
        end;
    end
    
    pause(0.1)
end;

mr_close_read_buffer('c:/tmp/Test');