function trigger_accumulate_mocap_calibration_points(eventNumber)
global mr;

% if we are waiting for new calibration points
if isfield(mr.mocap, 'numberOfCalibrationPointsNeeded') &&  mr.mocap.numberOfCalibrationPointsNeeded > 0
    
    mr.mocap.calibrationPoints(end+1,:) = mr.mocap.markerPosition(1,:);
       
    % add some text to the log
    currentLogText= get(mr.mocap.calibrationGuiHandles.prompt, 'String');
    newText = ['Calibration point ' num2str(size(mr.mocap.calibrationPoints, 1)) ' entered.'];
    set(mr.mocap.calibrationGuiHandles.prompt, 'String', newText);
    
    fprintf('Calibration point %d entered.\n', size(mr.mocap.calibrationPoints, 1));
    beep;
    
    % if enough calibration points are specified, add the object and update the
    %gui
    if size(mr.mocap.calibrationPoints, 1) >= mr.mocap.numberOfCalibrationPointsNeeded
        
        % add some markers to show calibration points
        for i=1:mr.mocap.numberOfCalibrationPointsNeeded
            markerSphere = vrSphere(mr.mocap.mocapWorld, mr.mocap.calibrationPoints(i,:), 0.2, true);
        end;
        
        vrObjectLabel = get(mr.mocap.calibrationGuiHandles.editLabel,'String');
        mr.mocap.objectCollection = mr.mocap.objectCollection.addObjectFromCalibration(mr.mocap.waitingForObjectCalibrationOfType, mr.mocap.calibrationPoints(1:mr.mocap.numberOfCalibrationPointsNeeded,:), vrObjectLabel,mr.mocap.mocapWorld);
        
        mr.mocap.numberOfCalibrationPointsNeeded = 0;
        mr.mocap.calibrationPoints = [];
        
        % enable gui button for adding new objects in the gui
        set(mr.mocap.calibrationGuiHandles.newBoxPushbutton, 'Enable', 'on');
        set(mr.mocap.calibrationGuiHandles.newSpherePushbutton, 'Enable', 'on');
        
        % add some text to the log
        currentLogText= get(mr.mocap.calibrationGuiHandles.prompt, 'String');
        newText = ['A new ' mr.mocap.waitingForObjectCalibrationOfType ' is added and labeled.'];
        set(mr.mocap.calibrationGuiHandles.prompt, 'String',newText);
        
        mr.mocap.waitingForObjectCalibrationOfType = [];
    end;
    
end;